"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AgentFactory = void 0;
const HttpAgent_1 = require("./HttpAgent");
const HttpsAgent_1 = require("./HttpsAgent");
class AgentFactory {
    static create(initialOption) {
        let agent;
        if (initialOption.type === 'http') {
            agent = new HttpAgent_1.HttpAgent(initialOption);
        }
        else {
            agent = new HttpsAgent_1.HttpsAgent(initialOption);
        }
        return agent;
    }
}
exports.AgentFactory = AgentFactory;
//# sourceMappingURL=Agent.js.map