"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpsAgent = void 0;
const https_1 = require("https");
const tls_1 = require("tls");
const client_1 = require("./client");
class HttpsAgent extends https_1.Agent {
    socket;
    constructor(options = {}) {
        super();
        const { proxyHost, proxyPort } = options;
        this.socket = new client_1.Socks5Client({
            host: proxyHost,
            port: proxyPort,
        });
    }
    createConnection(options) {
        return this.socket.proxyConnect(options, (call) => {
            this.socket.socket = tls_1.connect({
                servername: options.host,
                socket: this.socket.socket,
            }, () => {
                this.socket.authorized = this.socket.socket.authorized;
                call.call(this.socket);
            });
        });
    }
}
exports.HttpsAgent = HttpsAgent;
//# sourceMappingURL=HttpsAgent.js.map