/// <reference types="node" />
import { Socket } from 'net';
import { VoidFunction } from '@powerfulyang/utils';
import { EventEmitter } from 'events';
export interface Socks5ClientOptions {
    host?: string;
    hostname?: string;
    port?: number;
    username?: string;
    password?: string;
}
export interface CreateConnectionOptions {
    host: string;
    port: number;
}
export declare class Socks5Client extends EventEmitter {
    private readonly hostname;
    private readonly port;
    private readonly username?;
    private readonly password?;
    private targetHost;
    private targetPort;
    socket: Socket;
    write: any;
    read: any;
    cork: any;
    uncork: any;
    resume: any;
    writable: boolean;
    readable: boolean;
    destroy: any;
    pause: any;
    authorized: any;
    constructor(options?: Socks5ClientOptions);
    end(data: string | Uint8Array, encoding: (() => void) | undefined): void;
    destroySoon(): any;
    proxyConnect(options: CreateConnectionOptions, onProxy?: VoidFunction): this;
    onProxy(): void;
    private authenticate;
    private static getErrorMessage;
    private addIPv4Section;
    private addIPv6Section;
    private connectToHost;
}
